CREATE TABLE PAISES (
  ID NUMBER (38,0) NOT NULL PRIMARY KEY,
  NOME VARCHAR2(50) NOT NULL
);

CREATE TABLE ESTADOS (
    ID NUMBER (38,0) NOT NULL PRIMARY KEY,
    NOME VARCHAR2(50) NOT NULL,
    ID_PAISES NUMBER NOT NULL,
    FOREIGN KEY(ID_PAISES)
            REFERENCES PAISES( ID )
            ON DELETE CASCADE
);

CREATE TABLE CIDADES (
    ID NUMBER NOT NULL PRIMARY KEY,
    NOME VARCHAR2(100) NOT NULL,
    ID_ESTADOS NUMBER NOT NULL,
    FOREIGN KEY( ID_ESTADOS )
        REFERENCES ESTADOS( ID )
        ON DELETE CASCADE
);

CREATE TABLE CLIENTES (
    ID NUMBER NOT NULL PRIMARY KEY,
    CPF CHAR(14) NOT NULL,
    NOME VARCHAR(100) NOT NULL
);

CREATE TABLE CIDADES_X_CLIENTES(
    ID_CIDADES NUMBER NOT NULL,
    ID_CLIENTES NUMBER NOT NULL,
    CONSTRAINT ID_CIDADES_CLIENTES PRIMARY KEY( ID_CIDADES, ID_CLIENTES ),
    FOREIGN KEY( ID_CIDADES )
        REFERENCES CIDADES( ID ),
    FOREIGN KEY( ID_CLIENTES )
        REFERENCES CLIENTES( ID )
);

CREATE TABLE BANCOS(
    CODIGO NUMBER NOT NULL PRIMARY KEY,
    NOME VARCHAR(50) NOT NULL
);

CREATE TABLE AGENCIAS(
    CODIGO NUMBER NOT NULL PRIMARY KEY,
    NOME VARCHAR(50) NOT NULL,
    CODIGO_BANCOS NUMBER NOT NULL,
    ID_CIDADES NUMBER NOT NULL,
    FOREIGN KEY( CODIGO_BANCOS )
        REFERENCES BANCOS( CODIGO ),
    FOREIGN KEY( ID_CIDADES )
        REFERENCES CIDADES( ID )        
);

CREATE TABLE TIPO_CONTA(
    ID NUMBER NOT NULL PRIMARY KEY,
    DESCRICAO VARCHAR2(10) CHECK( DESCRICAO IN ('PJ','PF','CONJ', 'INVEST') )
);

CREATE TABLE CONTAS(
    ID NUMBER NOT NULL PRIMARY KEY,
    ID_TIPO_CONTA NUMBER NOT NULL,
    CODIGO_AGENCIAS NUMBER NOT NULL,
    NUMER NUMBER NOT NULL,
    SALDO DECIMAL NOT NULL,
    FOREIGN KEY( ID_TIPO_CONTA )
        REFERENCES TIPO_CONTA( ID ),
    FOREIGN KEY( CODIGO_AGENCIAS )    
        REFERENCES AGENCIAS( CODIGO )
);

CREATE TABLE MOVIMENTACOES(
    ID NUMBER NOT NULL PRIMARY KEY,
    VALOR DECIMAL NOT NULL,
    TIPO VARCHAR2(10) CHECK( TIPO IN ( 'DEBITO', 'CREDITO' ) ),
    ID_CONTAS NUMBER NOT NULL,
    FOREIGN KEY( ID_CONTAS )
        REFERENCES CONTAS( ID )
        ON DELETE CASCADE
);

CREATE TABLE CONTAS_X_CLIENTES(
    ID_CONTAS NUMBER NOT NULL,
    ID_CLIENTES NUMBER NOT NULL,
    CONSTRAINT ID_CONTAS_CLIENTES PRIMARY KEY ( ID_CONTAS, ID_CLIENTES ),
    FOREIGN KEY( ID_CONTAS )
        REFERENCES CONTAS( ID ),
    FOREIGN KEY( ID_CLIENTES )
        REFERENCES CLIENTES( ID )
);